jQuery(function($){

	if(usuarioConectado===USUARIO_HPS){		
		$("#PlanesEstrategicos").rup_table({	
			url: $.rup.CTX_PATH + "planesestrategicos",
			colNames: [
				"codplane",
				"codplanificacion",
				"codentidad",
				$.rup.i18n.app.campos_tabla_planes_estrategicos["nombreEntidad"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechas"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["nombre"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["txostena"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["tieneVersion"],
				"txostenaCod",
				"codVersion",
				"numTieneVersion",
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechaAceptacion"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechaModificacion"],
				"numPgAlta"
			],
			colModel: [
				{ 	name: "codplane",
					index: "CODPLANE",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "planificacion.codplanificacion",
					index: "CODPLANIFICACION",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "entidad.codentidad",
					index: "CODENTIDAD",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "entidad.desentidad",
					index: "DESENTIDAD",
					align: "left",
					width: 150,
					hidden: false,
					sortable: true
				},
				{ 	name: "anyos",
					index: "anyoinicio",
					align: "left",
					width: 50,
					hidden: false,
					sortable: true
				},
				{ 	name: "nombreEsEu",
					index: "NOMBRE"+IDIOMA,
					align: "left",
					width: 80,
					hidden: false,
					sortable: true
				},
				{ 	name: "solitudTxostena",
					index: "SOLICITUDTXOSTENA",
					align: "left",
					width: 80,
					hidden: false,
					sortable: true,
					formatter: formatterTxostena
				},
				{ 	name: "tieneVersion",
					index: "TIENEVERSION",
					align: "center",
					width: 40,
					hidden: false,
					sortable: true,
					formatter: formatterTieneVersion
				},
				{ 	name: "solitudTxostena",
					index: "SOLICITUDTXOSTENA",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "codVersion",
					index: "CODVERSION",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "tieneVersion",
					index: "TIENEVERSION",
					align: "center",
					width: 0,
					hidden: true
				},
				{ 	name: "fechaAceptacionPlan",
					index: "fechaAceptacionPlan",
					align: "center",
					width: 70,					
					hidden: false,
					sortable: true
				},
				{ 	name: "fechaModificacion",
					index: "FECHAMODIFICACION",
					align: "center",
					width: 70,
					hidden: false,
					sortable: true
				},
				{ 	name: "numPgAlta",
					index: "NUMPGALTA",
					align: "center",
					width: 0,
					hidden: true
				}
	        ],

	        model:"PlanesEstrategicos",
	        usePlugins:[
				"formEdit",
	        	"feedback",
				"toolbar",
	        	"contextMenu",
	        	"responsive",
	        	"filter"
	         	],
			primaryKey: "codplane",
			sortname: "FECHAMODIFICACION",
			sortorder: "DESC",
			loadOnStartUp: true,
			feedback:{
				config:{
					block: false
				}
			},
			core:{
		    	showOperations:{
		    		"clone": false,
		    		"delete": false,
		    		"edit": false		    		
		    	},
		    	operations:{		    				    	
		    		"irArbol":{
			    		name: $.rup.i18n.app.ab39a_botonera.xehetasuna,
			    		enabled: function(){	
			    			return true;
			    		},
			    		callback: function(key, options){			    			
                    		irArbol();                    		
			    		}
		    		},
			    	"versiones":{
			    		name: $.rup.i18n.app.ab39a_botonera.versiones,
			    		enabled: function(){
			    			return $("#PlanesEstrategicos").rup_table("getRowData", $("#PlanesEstrategicos").rup_table("getSelectedRows")[0]).tieneVersion>1;
			    		},
			    		callback: function(key, options){	
			    			abrirVersionesDialog();
			    		}
			    	}
		    	}
	    	},
	        formEdit:{
	        	detailForm: "#PlanesEstrategicos_detail_div",
				addEditOptions: {
	    			reloadAfterSubmit:true
	    		},
				deleteOptions:{
					reloadAfterSubmit:true
				},
	         	validate:{ 
	    			rules:{
	    				"codplane":{
							required: false
	    					},
	    				"planificacion.codplanificacion":{
							required: false
	    					},
	    				"entidades.codentidad":{
							required: false
	    					},
	    				"anyoinicio":{
							required: false, digits:true, maxlength:4, minlength:4
	    					},
	    				"anyofin":{
							required: true, digits:true, maxlength:4, minlength:4
	    					},
	    				"indiceObligat":{
							required: false, digits:true, maxlength:3
	    					},
	    				"nivelCumplimientoReqeus":{
							required: false, digits:true, maxlength:3
	    					},
	    				"fechaAceptacionPlan":{
							required: false, date:true
	    					},
	    				"nombre":{
							required: false,maxlength:250
	    					},
	    				"nombreeus":{
							required: true,maxlength:250
	    					},
						"porcentajeBiling":{
							required: false, digits:true, maxlength:3
						}
	    			}
	    		}
	        },onSelectRow:function(id){
	        	controlarVersiones(null);
	    	},loadComplete:function(event){
	    		controlarVersiones(event);
	    		
	    	}
		});
	
		
		function controlarVersiones(event){
			var idsel = $("#PlanesEstrategicos").rup_table("getActiveRowId");
			var dato=$("#PlanesEstrategicos").rup_table("getRowData",idsel);
    		var tieneVersion=false;
    		if (dato!=undefined && dato.tieneVersion>1){
    			tieneVersion=true;
    		}
    		if (!tieneVersion){
    			$("[id='PlanesEstrategicos_contextMenu_versiones']").hide();
    			$("[id='PlanesEstrategicos_toolbar##btnVersiones']").attr("disabled", true);
    			/*$("[id='PlanesEstrategicos_toolbar##btnVersiones']").enabled=function(){
    				return false;
    			};*/
    			$("[id='PlanesEstrategicos_toolbar##btnVersiones']").toggleClass("ui-state-disabled",true);
    		}else{
    			$("[id='PlanesEstrategicos_contextMenu_versiones']").show();
    			$("[id='PlanesEstrategicos_toolbar##btnVersiones']").attr("disabled", false);
    			/*$("[id='PlanesEstrategicos_toolbar##btnVersiones']").enabled=function(){
    				return true;
    			};*/
    			$("[id='PlanesEstrategicos_toolbar##btnVersiones']").toggleClass("ui-state-disabled",false);
    		}
		};
				
	}else{
		
		$("#PlanesEstrategicos").rup_table({	
			url: $.rup.CTX_PATH + "planesestrategicos",
			colNames: [
				"codplane",
				"codplanificacion",
				"codentidad",
				$.rup.i18n.app.campos_tabla_planes_estrategicos["nombreEntidad"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechas"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["nombre"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["txostena"],
				"txostenaCod",
				"codVersion",
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechaAceptacion"],
				$.rup.i18n.app.campos_tabla_planes_estrategicos["fechaModificacion"],
				"numPgAlta"
			],
			colModel: [
				{ 	name: "codplane",
					index: "CODPLANE",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "planificacion.codplanificacion",
					index: "CODPLANIFICACION",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "entidad.codentidad",
					index: "CODENTIDAD",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "entidad.desentidad",
					index: "DESENTIDAD",
					align: "left",
					width: 150,
					hidden: false,
					sortable: true
				},
				{ 	name: "anyos",
					index: "anyoinicio",
					align: "left",
					width: 80,
					hidden: false,
					sortable: true
				},
				{ 	name: "nombreEsEu",
					index: "NOMBRE"+(IDIOMA=="es"?"":"eus"),
					align: "left",
					width: 150,
					hidden: false,
					sortable: true
				},
				{ 	name: "solitudTxostena",
					index: "SOLICITUDTXOSTENA",
					align: "left",
					width: 80,
					hidden: false,
					sortable: true,
					formatter: formatterTxostena
				},
				{ 	name: "solitudTxostena",
					index: "SOLICITUDTXOSTENA",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "codVersion",
					index: "CODVERSION",
					align: "left",
					width: 150,
					hidden: true,
					sortable: true
				},
				{ 	name: "fechaAceptacionPlan",
					index: "fechaAceptacionPlan",
					align: "center",
					width: 70,					
					hidden: false,
					sortable: true
				},
				{ 	name: "fechaModificacion",
					index: "FECHAMODIFICACION",
					align: "center",
					width: 70,
					hidden: false,
					sortable: true
				},
				{ 	name: "numPgAlta",
					index: "NUMPGALTA",
					align: "center",
					width: 0,
					hidden: true
				}
	        ],

	        model:"PlanesEstrategicos",
	        usePlugins:[
				"formEdit",
	        	"feedback",
				"toolbar",
	        	"contextMenu",
	        	"responsive"
	         	],
	        primaryKey: "codplane",
			sortname: "FECHAMODIFICACION",
			sortorder: "DESC",
			loadOnStartUp: true,
			feedback:{
				config:{
					block: false
				}
			},
			core:{
		    	showOperations:{
		    		"clone": false,
		    		"delete": false,
		    		"edit": false
		    	},
		    	operations:{
		    		"eliminarPlanE":{
			    		name: $.rup.i18n.app.ab39a_botonera.eliminar,
			    		enabled: function(){	
			    			return (usuarioConectado == USUARIO_TEC_ENTIDAD);
			    		},
			    		callback: function(key, options){				    			
                    		eliminarPlanE();                    		
			    		}
			    	},			    	
		    		"irArbol":{
			    		name: $.rup.i18n.app.ab39a_botonera.xehetasuna,
			    		enabled: function(){	
			    			return true;
			    		},
			    		callback: function(key, options){				    			
                    		irArbol();                    		
			    		}
			    	},		    		
		    		"solicitarTxostena":{
			    		name: $.rup.i18n.app.ab39a_botonera.solicitarTxostena,
			    		enabled: function(){
			    			return (tipoEntidad!=ENPRESA_PRIBATUA_ID);			    				    						    			
			    		},
			    		callback: function(key, options){		
			    			var celdaSeleccionada = $("#PlanesEstrategicos").rup_table("getSelectedRows");
                    		if (celdaSeleccionada[0]!=undefined) {	
				    			$.rup_messages("msgConfirm", {
			                        message: $.rup.i18n.app.msg_confirm["msgConfirmSolicitarTxostena"],
			                        title: $.rup.i18n.app.msg_confirm["tituloSolicitarTxostena"],
			                        OKFunction: function () {		                        	
			                    			solicitarTxostena();		                    		
			                        }
				    			});
                    		}
			    		}
		    		},
		    		"copiarPlanE":{
		    			name: $.rup.i18n.app.ab39a_botonera.copiarplane,
		    			enabled: function(){	
		    				return true;
		    			},
		    			callback: function(key, options){	
		    				abrirCopiarPlanEDialog();
		    			}
		    		}
		    	}
	    	},
	        formEdit:{
	        	detailForm: "#PlanesEstrategicos_detail_div",
				addEditOptions: {
	    			reloadAfterSubmit:true
	    		},
				deleteOptions:{
					reloadAfterSubmit:true
				},
	         	validate:{ 
	    			rules:{
	    				"codplane":{
							required: false
	    					},
	    				"planificacion.codplanificacion":{
							required: false
	    					},
	    				"entidades.codentidad":{
							required: false
	    					},
	    				"anyoinicio":{
							required: true, digits:true, maxlength:4, minlength:4
	    					},
	    				"anyofin":{
							required: true, digits:true, maxlength:4, minlength:4
	    					},
	    				"indiceObligat":{
							required: false, digits:true, maxlength:3
	    					},
	    				"nivelCumplimientoReqeus":{
							required: false, digits:true, maxlength:3
	    					},
	    				"fechaAceptacionPlan":{
							required: false, date:true
	    					},
	    				"nombre":{
							required: false, maxlength:250
	    					},
	    				"nombreeus":{
							required: true, maxlength:250
	    					},
						"porcentajeBiling":{
							required: false, digits:true,maxlength:3
						}
	    				}
	    		}
	        }
		});
	}
	
	$('#fechaAceptacionPlan_detail_table').rup_date({});
	
	
	$('.esNumero').on('input', function () { 
	    this.value = this.value.replace(/[^0-9]/g,'');
	});
	
	
	
	if(usuarioConectado == USUARIO_TEC_ENTIDAD){
		$("#PlanesEstrategicos").on("jqGridAddEditAfterFillData", function(event, $form, oper){
			
			if(oper === 'add') {
				 $("#entidad_tipoEntidad_detail_table").val(tipoEntidad);
				 $("#entidad_codentidad_detail_table").val(entidadObj.codentidad);	
			}
		});
		
				
		if(tipoEntidad==HERRI_ADMINISTRAZIOA_ID){
			//Cargar el campo plangintzaldia cuando se pulsa alta (en el caso de la administracion publica)
			$("[id='PlanesEstrategicos_toolbar##btnAdd']").click(function(){
				 $.rup_ajax({
						url : $.rup.CTX_PATH + "planificacion/getAnioPlanificacion",
						contentType : "application/json",
						cache : false,
						dataType : "json",
						type : "GET",
						success : function(response) {
							cargarFechas(response);
						},
						error : function(error) {
							ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorFechas"]);
						}
					});
			});
		}
		$("[id='PlanesEstrategicos_toolbar##btnAdd']").show();		
		$("[id='PlanesEstrategicos_contextMenu_add']").show();		
		$("[id='PlanesEstrategicos_toolbar##btnCopiarPlanE']").show();
		
		if(tipoEntidad==ENPRESA_PRIBATUA_ID){
			$("[id='PlanesEstrategicos_toolbar##btnSolicitarTxostena']").hide();	
			$("[id='PlanesEstrategicos_contextMenu_solicitarTxostena']").hide();
		}else{			
			$("[id='PlanesEstrategicos_toolbar##btnSolicitarTxostena']").show();
			$("[id='PlanesEstrategicos_contextMenu_solicitarTxostena']").show();
		}
		
		if(solicInfor == 1){
			$(".idiomaEs").hide();
		}else{
			$(".idiomaEs").show();
		}
		
	}else{
		$("[id='PlanesEstrategicos_toolbar##btnAdd']").hide();
		$("[id='PlanesEstrategicos_contextMenu_add']").hide();			
	}
	function cargarFechas(response){
		var textoFechas =  response.fechainicio +'-'+response.fechafin;
		 $("#planificacion_textplanificacion_detail_table").val(textoFechas);
		 $("#planificacion_codplanificacion_detail_table").val(response.codplanificacion);
		 $("#planificacion_fechafin_detail_table").val(response.fechafin);
		 $("#planificacion_fechainicio_detail_table").val(response.fechainicio);
	}

	function eliminarPlanE(){
		$("#PlanesEstrategicos_feedback").rup_feedback("close");
		var selectedRowPlanes = ab39aUtils.tabla.getSelectedRow($("#PlanesEstrategicos"));			
		if(selectedRowPlanes.solitudTxostena==1){
			ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorBajaPETxostena"]);	
			return false;
		}
		if(selectedRowPlanes.numPgAlta!=0){
			ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorBajaPEPlanesGestion"]);	
			return false;
		}	
		$.rup_messages("msgConfirm", {
	        message: $.rup.i18nParse($.rup.i18n.app,"campos_tabla_planes_estrategicos.mensElimPlan"),
	        title: "",
	        OKFunction: function () {
	        	$.rup_ajax({
					url : $.rup.CTX_PATH + "planesestrategicos/eliminarPlan/"+selectedRowPlanes.codplane + "/" + selectedRowPlanes.codVersion, 
					contentType : "application/json",
					cache : false,
					dataType : "json",
					type : "GET",
					success : function(response) {
						$("#PlanesEstrategicos").rup_table("reloadGrid", true);
						ab39aUtils.feedback.pintarFeedbackOk($.rup.i18n.app.campos_tabla_planes_estrategicos["elimok"]);
					},
					error : function(error) {
						ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorGral"]);
					}
				});
	         }
	    }); 
		
	}
		
	// Formatter txostena
	function formatterTxostena(cellval) {
		var resultado = "";
		if(cellval != undefined ) {
			if(TXOSTENA_SOLICITADO == cellval) {
				resultado = $.rup.i18n.app.campos_tabla_planes_estrategicos['txostenaSolicitado'];
			} else if(TXOSTENA_NO_SOLICITADO == cellval) {
				resultado = $.rup.i18n.app.campos_tabla_planes_estrategicos['txostenaNoSolicitado'];
			}
		}
		return resultado;
	}
	
	
	//formate si tiene version
	function formatterTieneVersion(cellval){
		var resultado = "";
		if(cellval != undefined && cellval >1) {
			resultado = $.rup.i18n.app.campos_elementos['elementoSi'];
		}else{
			resultado = $.rup.i18n.app.campos_elementos['elementoNo'];
		}
		return resultado;
	}
	
	//Modifica el campos solicatr txostena del registro seleccionado
	function solicitarTxostena(){		
		
			var selectedRow = ab39aUtils.tabla.getSelectedRow($("#PlanesEstrategicos"));
			if(selectedRow.solitudTxostena== TXOSTENA_NO_SOLICITADO){				
				var codplane = selectedRow.codplane;
				 $.rup_ajax({
						url : $.rup.CTX_PATH + "planesestrategicos/editInforme/"+codplane, 
						contentType : "application/json",
						cache : false,
						dataType : "json",
						type : "GET",
						success : function(response) {
							$("#PlanesEstrategicos").rup_table("reloadGrid", true);
							ab39aUtils.feedback.pintarFeedbackOk($.rup.i18n.app.feedBack_ok["informeSolicitadoOk"]);
						},
						error : function(error) {
							ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorInformeNoSolicitado"]);
						}
					});
			}else{
				ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorInformeSolicitado"]);
			}
		
	}
	
	
	$("#PlanesEstrategicos").rup_table('setGridParam',{ ondblClickRow : function(rowid){ redirigir_xehetasuna(); } });
	
	function redirigir_xehetasuna(){		
		irArbol();
	}
	

	$("#porcentajeBilingLiteral").rup_tooltip({
		content: {
			text: $.rup.i18n.app.toolTip["elebidunEhunekoa"],
			title: {
				text: $.rup.i18n.app.toolTip["elebidunEhunekoaTitulo"]
			}
		}
	});
	$("#indiceObligaLiteral").rup_tooltip({
		content: {
			text: $.rup.i18n.app.toolTip["derrigortasunIndizea"],
			title: {
				text: $.rup.i18n.app.toolTip["derrigortasunIndizeaTitulo"]
			}
		}
	});
	$("#nivelCumplimientoLiteral").rup_tooltip({
		content: {
			text: $.rup.i18n.app.toolTip["betetzeMaila"],
			title: {
				text: $.rup.i18n.app.toolTip["betetzeMailaTitulo"]
			}
		}
	});

});


function irArbol(){	
	var selectedRow = ab39aUtils.tabla.getSelectedRow($("#PlanesEstrategicos"));
	var celdaSeleccionada = $("#PlanesEstrategicos").rup_table("getSelectedRows");
	if (celdaSeleccionada[0]!=undefined) {		
		ab39aUtils.util.bloquearInterfaz();
		window.location = $.rup.CTX_PATH + "elementosArbol/arbol/detalle/" + selectedRow.codplane + "/PE/" + selectedRow.codVersion + "/0";
	}	
}

function abrirVersionesDialog(){
	ab39aUtils.util.bloquearInterfaz();
	var selectedRow = ab39aUtils.tabla.getSelectedRow($("#PlanesEstrategicos"));
	if(selectedRow!==undefined){
		$('#divVersiones_Dialog').rup_dialog({			
				title :$.rup.i18n.app.campos_tabla_planes_estrategicos['versiones'],
				type: $.rup.dialog.AJAX, 
				url: ab39aUtils.util.setUrlNoCachePortalWar($.rup.CTX_PATH + "planesestrategicos/versiones/"+selectedRow.codplane),
				autoOpen : true,
				closeOnEscape : true,
				modal : true,
				resizable : false,
				minWidth : 800,
				minHeight : 300,
				ajaxOptions: {
					success: function (data, textStatus, XMLHttpRequest){
	
					},
					error: function (error){
					}
				},
				open: function(){
					
				},
				load: function(){
					ab39aUtils.util.desbloquearInterfaz();
				},
				close: function(event, ui) { 
					
				}
			});	
	}
}


function abrirCopiarPlanEDialog(){
	ab39aUtils.util.bloquearInterfaz();
	
		$('#divCopiarPlanE_Dialog').rup_dialog({
				title :$.rup.i18n.app.campos_tabla_planes_estrategicos['copiarplane'],
				type: $.rup.dialog.AJAX, 
				url: ab39aUtils.util.setUrlNoCachePortalWar($.rup.CTX_PATH + "planesestrategicos/copiarplane"),
				autoOpen : true,
				closeOnEscape : true,
				modal : true,
				resizable : false,
				minWidth : 800,
				minHeight : 300,
				ajaxOptions: {
					success: function (data, textStatus, XMLHttpRequest){
	
					},
					error: function (error){
					}
				},
				open: function(){
					
				},
				load: function(){
					ab39aUtils.util.desbloquearInterfaz();
				},
				close: function(event, ui) { 
					//ab39aUtils.util.desbloquearInterfaz();
					//Parche para saber si se ha abierto en algun momento la capa. Si no es así, entonces no tengo que destruirla
					if($('#divCopiarAltaPlanE_Dialog')[0].innerHTML!=="&nbsp;"){
						$('#divCopiarAltaPlanE_Dialog').rup_dialog("destroy");
						$("#PlanesEstrategicos").rup_table("reloadGrid", true);
					}
				}
			});	
}